# NOTE: Derived from blib/lib/ClearCase/Wrapper.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package ClearCase::Wrapper;

#line 1304 "blib/lib/ClearCase/Wrapper.pm (autosplit into blib/lib/auto/ClearCase/Wrapper/_inview.al)"
## undocumented helper function for B<workon>
sub _inview {
    my $tag = (split(m%[/\\]%, $ENV{CLEARCASE_ROOT}))[-1];
    Argv->new([$^X, '-S', $0, 'setcs'], [qw(-sync -tag), $tag])->system;
    my $cs = Argv->new({-autochomp=>1}, [$^X, '-S', $0, 'catcs'],
						    [qw(--start -tag)], $tag);
    my $iwd = $cs->opts(qw(--start -tag))->qx;
    my $exe;

    # If -exec foo was passed to workon it'll show up as -_exec foo here.
    GetOptions('_exec=s' => \$exe) if grep /^-_/, @ARGV;

    # If an initial working dir is supplied cd to it, then check for
    # a viewenv file and require it if so.
    if ($iwd) {
	print "+ cd $iwd\n";
	# ensure $PWD is set to $iwd within req'd file
	require Cwd;
	Cwd::chdir($iwd) || warn "$iwd: $!\n";
	my($cli) = grep /^viewenv=/, @ARGV;
	my $env = (split /=/, $cli)[1] if $cli;
	$env ||= $cs->opts(qw(--viewenv -tag))->qx;
	$env ||= '.viewenv.pl';
	chomp $env;
	if (-f $env) {
	    local @ARGV = grep /^\w+=/, @ARGV;
	    print "+ reading $env ...\n";
	    eval { require $env };
	    warn Msg('W', $@) if $@;
	}
    }

    # A reasonable default for everybody.
    $ENV{CLEARCASE_MAKE_COMPAT} ||= 'gnu';

    for (grep /^(CLEARCASE_)?ARGV_/, keys %ENV) { delete $ENV{$_} }
    delete $ENV{LOGNAME} if MSWIN;

    # Exec the user's shell or the value of the -_exec flag.
    if (! $exe) {
	$exe = $ENV{SHELL} || (-x '/bin/sh' ? '/bin/sh' : (MSWIN ? 'cmd':'sh'));
	$exe = 'c:/mksnt/sh' if MSWIN && -x 'c:/mksnt/sh.exe'; # MKS hack
    }
    Argv->new($exe)->exec;
}

# end of ClearCase::Wrapper::_inview
1;
