# NOTE: Derived from blib/lib/ClearCase/Wrapper.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package ClearCase::Wrapper;

#line 714 "blib/lib/ClearCase/Wrapper.pm (autosplit into blib/lib/auto/ClearCase/Wrapper/lsprivate.al)"
sub lsprivate {
    my %opt;
    GetOptions(\%opt, qw(directory recurse all avobs
						ext relative type=s visible));

    my $lsp = ClearCase::Argv->new(@ARGV);
    $lsp->parse(qw(co|do|other|short|long tag|invob=s));

    my $pname = '.';

    # Extension: allow [dir] argument
    if ($lsp->args) {
	chomp(($pname) = $lsp->args);
	$lsp->args;
	# Default to -rec but accept -dir.
	$opt{recurse} = 1 unless $opt{directory} || $opt{all} || $opt{avobs};
    }

    # Extension: implement [-dir|-rec|-all|-avobs]
    if ($opt{all}) {
	$lsp->opts($lsp->opts, '-invob', $pname);
    } elsif ($opt{directory} || $opt{recurse}) {
	require Cwd;
	my $dir = Cwd::abs_path($pname);
	my $tag = $lsp->flag('tag');
	if ($dir =~ s%/+view/([^/]+)%%) {	# UNIX view-extended path
	    $tag ||= $1;
	} elsif ($dir =~ s%^[A-Z]:%%) {		# DOS view-extended path
	    if ($tag) {
		$dir =~ s%^/$tag%%i;
	    } else {
		$tag = ViewTag();
	    }
	} elsif (!$tag) {
	    $tag = ViewTag();
	}
	$lsp->opts($lsp->opts, '-tag', $tag) if !$lsp->flag('tag');
	chomp(my @privs = sort $lsp->qx);
	exit $? if $? || !@privs;
	for (@privs) {
	    if (MSWIN) {
		s/^[A-Z]://i;
		s%\\%/%g;
	    }
	    s%(/+view)?/$tag%%;
	}
	@privs = map {$_ eq $dir ? "$_/" : $_} @privs;
	my $action = $opt{relative} ? 'map ' : 'grep ';
	$action .= $opt{recurse} ? '{m%^$dir/(.*)%}' : '{m%^$dir/([^/]*)$%s}';
	$opt{type} ||= 'e' if $opt{visible};
	$action = "grep {-$opt{type}} $action" if $opt{type};
	my @results;
	eval qq(\@results = $action \@privs);
	exit 0 if !@results;
	if ($opt{ext}) {	# sort by extension
	    require File::Basename;
	    @results = map  { $_->[0] }
	       sort { "$a->[1]$a->[2]$a->[3]" cmp "$b->[1]$b->[2]$b->[3]" }
	       map  { [$_, (File::Basename::fileparse($_, '\.\w+'))[2,0,1]] }
	       @results;
	}
	for (@results) { print $_, "\n" }
	exit 0;
    }
    $lsp->exec;
}

# end of ClearCase::Wrapper::lsprivate
1;
