# NOTE: Derived from blib/lib/ClearCase/Wrapper.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package ClearCase::Wrapper;

#line 1133 "blib/lib/ClearCase/Wrapper.pm (autosplit into blib/lib/auto/ClearCase/Wrapper/setview.al)"
sub setview {
    $ENV{CLEARCASE_PROFILE} = $ENV{_CLEARCASE_WRAPPER_PROFILE}
				if defined($ENV{_CLEARCASE_WRAPPER_PROFILE});
    delete $ENV{_CLEARCASE_WRAPPER_PROFILE};
    delete $ENV{_CLEARCASE_PROFILE};
    return 0 if !MSWIN;
    my %opt;
    GetOptions(\%opt, qw(exec=s drive=s login ndrive persistent));
    Argv->inpathnorm(0);	# must suppress this for options like /del
    {
	# This hack seems necessary to support $(shell ...) in clearmake
	# under MKS 6.2. Don't know why, something to do with the
	# typeset -I COMSPEC in environ.ksh?
	my $comspec = $ENV{ComSpec} || $ENV{COMSPEC};
	delete $ENV{COMSPEC};
	($ENV{ComSpec} = $comspec) =~ s%\\%/%g;
    }
    $opt{'exec'} ||= $ENV{SHELL} || $ENV{ComSpec} || 'cmd.exe';
    my $vtag = $ARGV[-1];
    my @used = grep /\w:\s+\\\\/, Argv->new(qw(net use))->qx;
    my @views = grep /\s+\\\\view\\$vtag\b/, grep !/unavailable/i, @used;
    my @drives = map {/(\w:)/ && uc($1)} @views;
    my $drive = $opt{drive} ? uc($opt{drive}) : $drives[0];
    my $mounted = 0;
    my $pers = $opt{persistent} ? '/persistent:yes' : '/persistent:no';
    my %taken = map {/(\w:)\s+\\\\view(\S+)/ && uc($1) => $2} @used;
    if (!$drive) {
	ClearCase::Argv->startview($vtag)->autofail(1)->system
						    if ! -d "//view/$vtag";
	$mounted = 1;
	for (reverse 'G'..'Z') {
	    $drive = $_ . ':';
	    if (!$taken{$drive}) {
		local $| = 1;
		print "Connecting $drive to \\\\view\\$vtag ... ";
		last if !Argv->new(qw(net use),
				$drive, "\\\\view\\$vtag", $pers)->system;
	    }
	}
    } elsif ($opt{drive}) {
	$drive .= ':' if $drive !~ /:$/;
	die Msg('E', "$drive is in use by another view")
				if $taken{$drive} && $taken{$drive} ne $vtag;
	if (! -d $drive) {
	    $mounted = 1;
	    local $| = 1;
	    print "Connecting $drive to \\\\view\\$vtag ... ";
	    Argv->new(qw(net use), $drive, "\\\\view\\$vtag", $pers)->system;
	}
    }
    chdir "$drive/" || die Msg('E', "chdir $drive $!");
    $ENV{CLEARCASE_ROOT} = "\\\\view\\$vtag";
    $ENV{CLEARCASE_VIEWDRIVE} = $ENV{VD} = $drive;
    delete $ENV{LOGNAME};
    if ($mounted && !$opt{persistent}) {
	my $rc = Argv->new($opt{'exec'})->system;
	Argv->new(qw(net use), $drive, '/delete')->system;
	exit $rc;
    } else {
	Argv->new($opt{'exec'})->exec;
    }
}

# end of ClearCase::Wrapper::setview
1;
